#ifndef CONNECTION_H
#define CONNECTION_H

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <sys/sendfile.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <string>
#include <sstream>
#include <iostream>
#include <string.h>
#include "ServerData.h"

#define PORT 8000

using namespace std;

enum kRequest{
  rLIST,
  rACTION1,
  rACTION2,
  rSIZE,
  rGET,
  rCLOSED,
  rERROR
};

enum lRequest{
  lAUDIO,
  lVIDEO,
  lPICTURE,
  lERROR
};

class Connection{
 public:
  int sd_listen;
  int sd_current;
  struct sockaddr_in sin;
  struct sockaddr_in pin;
  ServerData kissData;
  int initSocket();
  void closeSockets(bool closel);
  int wait4kiss();
  int handleRequest();
  int handleList(string &listRequest);
  int handleAction1(string &action1Request);
  int handleAction2(string &action2Request);
  int handleGet(string &getRequest, int fdfile);
  int handleSize(string &sizeRequest);
  int getData(string &data);
  int sendData(string &data);
  kRequest getRequestType(string &sRequest);
  lRequest getListType(string &listRequest);
  int parseGet(string &getRequest,string &sFileName, int &iOffSet, int &iChunk);
  int getFileSize(string filename);
};

#endif
