#include "Connection.h"
#include <signal.h>
#include <sys/wait.h>

Connection dp150x;
bool bRunning = true;
pid_t pid = 149;

void serverShutdown(int signal){
  if(pid != 0){
    cout << "Shutting Down\n";
  }
  dp150x.closeSockets(true);
  exit(0);
}

void killTheChildren(int signal){
  /* Kill Something */
  while(waitpid(-1, NULL, WNOHANG) > 0){}
}

int main(){
  if(dp150x.kissData.parseConfigFile()){
    cout << "Error parsing config file\n";
    return 1;
  }

  signal(SIGINT, serverShutdown);
  signal(SIGCHLD, killTheChildren);

  if(dp150x.initSocket()){
    return 1;
  }
  
  int rev = 0;

  while(bRunning){
    
    if((rev = dp150x.wait4kiss()))
      bRunning = false;
        
    switch(pid = fork()){
    case -1:
      perror("The fork failed!");
      bRunning = false;
      rev = 1;
      break;
    case 0:
      rev = dp150x.handleRequest();
      bRunning = false;
      break;
    default:
      cout << "Connection Established\n";
      break;
    }    
    
  }
  if(pid != 0){
    dp150x.closeSockets(true);
  }
  else{
    dp150x.closeSockets(false);
  }

  return rev;
}
